-- ***************************************************************** 
--                                                                   
-- Licensed Materials - Property of IBM                              
--                                                                   
-- 5724-U69                                                          
--                                                                   
-- Copyright IBM Corp. 2013  All Rights Reserved.                    
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
--                                                                   
-- ***************************************************************** 

CREATE LOB TABLESPACE @TSPRE@LTP5
 	IN @DB_NAME@
 	USING STOGROUP @STOGRP@
 	BUFFERPOOL @BPLOB@; 

-- *****************************************************************
--
-- LAYOUT_MARKUP_NODE (1500)
--
-- *****************************************************************
DROP TABLE @SCHEMA@.LAYOUT_MARKUP_NODE;

CREATE TABLE @SCHEMA@.LAYOUT_MARKUP_NODE (
	PAGE_OID    VARCHAR(64)           NOT NULL,
	CREATED     DECIMAL(19,0)         NOT NULL,
	MODIFIED    DECIMAL(19,0)         NOT NULL,
	CONTENT     BLOB(1M),
 	CONSTRAINT PK1500 PRIMARY KEY (PAGE_OID)
)
IN @DB_NAME@.@TSPRE@RTP1;

CREATE UNIQUE INDEX @SCHEMA@.LAYOUT_MARKUP_NODE_PK
	ON @SCHEMA@.LAYOUT_MARKUP_NODE (PAGE_OID) 
	USING STOGROUP @STOGRP@
    BUFFERPOOL @BPINDEX@;

CREATE AUX TABLE @SCHEMA@.CONTENT_LOB_E
	IN @DB_NAME@.@TSPRE@LTP5 
	STORES @SCHEMA@.LAYOUT_MARKUP_NODE 
	COLUMN CONTENT;

CREATE INDEX @SCHEMA@.CONTENT_LOB_M 
	ON @SCHEMA@.CONTENT_LOB_E
	USING STOGROUP @STOGRP@
	BUFFERPOOL @BPINDEX@;

ALTER TABLE @SCHEMA@.WIREITEM
  ADD S_EVENTNAME VARCHAR(255);

ALTER TABLE @SCHEMA@.WIREITEM
  ADD T_EVENTNAME VARCHAR(255);

DROP TABLE @SCHEMA@.PREFERENCE_VALUE;

DROP TABLE @SCHEMA@.PREFERENCE;

-- *****************************************************************
--
-- Drop all columns except OID, DEFINITION_URL, and WIDGET_TYPE
-- from WIDGET_DEFINITION table
--
-- *****************************************************************
-- CREATE TABLE @SCHEMA@.WIDGET_DEFINITION_TEMP AS (SELECT OID, DEFINITION_URL, WIDGET_TYPE FROM @SCHEMA@.WIDGET_DEFINITION) WITH NO DATA;
-- INSERT INTO @SCHEMA@.WIDGET_DEFINITION_TEMP SELECT OID, DEFINITION_URL, WIDGET_TYPE FROM @SCHEMA@.WIDGET_DEFINITION;
-- DROP TABLE @SCHEMA@.WIDGET_DEFINITION;
-- RENAME @SCHEMA@.WIDGET_DEFINITION_TEMP TO @SCHEMA@.WIDGET_DEFINITION;

UPDATE @SCHEMA@.VERSION_INFO SET VERSION_DEV = 15 WHERE OID = '458202233263219661970198300000000000';
