-- ***************************************************************** 
--                                                                   
-- Licensed Materials - Property of IBM                              
--                                                                   
-- 5724-U69                                                          
--                                                                   
-- Copyright IBM Corp. 2013  All Rights Reserved.                    
--                                                                   
-- US Government Users Restricted Rights - Use, duplication or       
-- disclosure restricted by GSA ADP Schedule Contract with           
-- IBM Corp.                                                         
--                                                                   
-- ***************************************************************** 

USE @DB_NAME@;

-- *****************************************************************
--
-- LAYOUT_MARKUP_NODE (1500)
--
-- *****************************************************************
DROP TABLE @SCHEMA@.LAYOUT_MARKUP_NODE;

CREATE TABLE @SCHEMA@.LAYOUT_MARKUP_NODE (
	PAGE_OID    VARCHAR(64)           NOT NULL,
	CREATED     BIGINT                NOT NULL,
	MODIFIED    BIGINT                NOT NULL,
	CONTENT     VARBINARY(MAX),
 	CONSTRAINT PK1500 PRIMARY KEY (PAGE_OID)
);

GRANT INSERT,UPDATE,SELECT,DELETE ON @SCHEMA@.LAYOUT_MARKUP_NODE TO @DB_USER@;

ALTER TABLE @SCHEMA@.WIREITEM
  ADD S_EVENTNAME VARCHAR(255);

ALTER TABLE @SCHEMA@.WIREITEM
  ADD T_EVENTNAME VARCHAR(255);

DROP TABLE @SCHEMA@.PREFERENCE_VALUE;

DROP TABLE @SCHEMA@.PREFERENCE;

ALTER TABLE @SCHEMA@.WIDGET_DEFINITION DROP COLUMN WEBAPP_NAME;
ALTER TABLE @SCHEMA@.WIDGET_DEFINITION DROP COLUMN SUPPORTED_MODES;

declare @default sysname, @sql nvarchar(max)

select @default = name 
from sys.default_constraints 
where parent_object_id = object_id('@SCHEMA@.WIDGET_DEFINITION')
AND type = 'D'
AND parent_column_id = (
    select column_id 
    from sys.columns 
    where object_id = object_id('@SCHEMA@.WIDGET_DEFINITION')
    and name = 'SANDBOX'
    )

set @sql = N'alter table @SCHEMA@.WIDGET_DEFINITION drop constraint ' + @default
exec sp_executesql @sql

alter table @SCHEMA@.WIDGET_DEFINITION DROP COLUMN SANDBOX

UPDATE @SCHEMA@.VERSION_INFO SET VERSION_DEV = 15 WHERE OID = '458202233263219661970198300000000000';
