# delete old cache instances

caches = AdminConfig.list('ObjectCacheInstance')
cachelist = caches.split(lineSeparator)

for cache in cachelist:
	if cache.startswith('"MashupHub '):
		AdminConfig.remove(cache)
		print "removing old MashupHub cache instance " + cache

# create replication domain if needed
cell = AdminConfig.list('Cell')
drd = AdminConfig.getid('/DataReplicationDomain:HubReplDomain')

if (len(drd) < 1):
	print "creating replication domain"
	drd = AdminConfig.create('DataReplicationDomain', cell, '[[name HubReplDomain]]')
	datarepl = AdminConfig.createUsingTemplate('DataReplication', drd, '', '(templates/system|multibroker.xml#DataReplication_1)')
	AdminConfig.modify(datarepl, '[[numberOfReplicas -1]]')
else:
	datarepl = AdminConfig.showAttribute(drd, 'defaultDataReplicationSettings')

# create cluster scope cache instances
cp = AdminConfig.getid('/ServerCluster:/CacheProvider:CacheProvider')

hubattrs=[]
hubattrs.append(["name", "MashupHub feed region"])
hubattrs.append(["jndiName", "services/cache/feedRegion"])
hubattrs.append(["cacheSize", 2000])
hubattrs.append(["defaultPriority", 1])
hubattrs.append(["description", "Distributed Cache for MashupHub feed generation"])
hubattrs.append(["category", "MashupHub"])
hubattrs.append(["enableCacheReplication", "true"])
hubattrs.append(["replicationType", "PUSH"])
hubattrs.append(["memoryCacheSizeInMB", "256"])
print "creating MashupHub cache instance with cluster scope"
mhubfeedcache = AdminConfig.create('ObjectCacheInstance', cp, hubattrs)
mhubdrs = AdminConfig.createUsingTemplate('DRSSettings', mhubfeedcache, '[[messageBrokerDomainName HubReplDomain]]', '(templates/default|server-component-templates.xml#SessionDRSPersistence_1)') 

mmmsattrs=[]
mmmsattrs.append(["name", "MashupHub MMMS cache region"])
mmmsattrs.append(["jndiName", "services/cache/mmmsRegion"])
mmmsattrs.append(["cacheSize", 2000])
mmmsattrs.append(["defaultPriority", 1])
mmmsattrs.append(["description", "Distributed Cache for MashupHub Metering Monitoring and Measuring Service"])
mmmsattrs.append(["category", "MashupHub"])
mmmsattrs.append(["enableCacheReplication", "true"])
mmmsattrs.append(["replicationType", "PUSH"])
print "creating MMMS cache instance with cluster scope"
mmmscache = AdminConfig.create('ObjectCacheInstance', cp, mmmsattrs)
mmmsdrs = AdminConfig.createUsingTemplate('DRSSettings', mmmscache, '[[messageBrokerDomainName HubReplDomain]]', '(templates/default|server-component-templates.xml#SessionDRSPersistence_1)')

configattrs=[]
configattrs.append(["name", "MashupHub configuration region"])
configattrs.append(["jndiName", "services/cache/MashupHub/configRegion"])
configattrs.append(["cacheSize", 2000])
configattrs.append(["defaultPriority", 1])
configattrs.append(["description", "Distributed Cache for MashupHub configuration"])
configattrs.append(["category", "MashupHub"])
configattrs.append(["enableCacheReplication", "true"])
configattrs.append(["useListenerContext", "true"])
configattrs.append(["replicationType", "PUSH"])
print "creating MashupHub config cache instance with cluster scope"
configcache = AdminConfig.create('ObjectCacheInstance', cp, configattrs)
configdrs = AdminConfig.createUsingTemplate('DRSSettings', configcache, '[[messageBrokerDomainName HubReplDomain]]', '(templates/default|server-component-templates.xml#SessionDRSPersistence_1)')

AdminConfig.save()
