if(!dojo._hasResource["com.ibm.customize.ChangeStyleController"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.ChangeStyleController"] = true;
 // This is a controller that customizes the styles of a page

dojo.provide("com.ibm.customize.ChangeStyleController");

com.ibm.customize.ChangeStyleController = {
	current: "",			// the style currently selected on the shelf
	currentSet: "",				// the style currently set on the page

/***********************************************/
/*       Customize Controller API			   */
/***********************************************/
	store: null,		// a datastore to save model changes
	item: null,			// an item in the store representing the current page to which changes will be made
	parent: null,		// a pointer to this controller's parent, if one exists
	dirty: false,		// true if there are changes pending
	started: false,		// true if the widget is started up
	refresh: false,		// true if a page refresh is required to show saved changes

	startup: function(/*Object?/Widget?*/parent){
		// summary: sets some variables, sets up the UI and prepares the stylesheet links so they can be switched out smoothly
		// parent: a reference to the parent of this controller
		this.started = true;
		this.current = this.currentSet;
		this.parent = parent;
		if(this.setupUI) this.setupUI();
	},
		
	makeDirty: function(/*bool*/change){
		// summary: changes the dirty attribute
		// change: value to assign to the dirty attribute
		this.dirty = change;
	},
		
	processChange: function(/*Object*/args){
		// summary: used as an event handler for when a user clicks on a result
		this.apply(args);
		if(!this.parent) {
			this.beforeSubmit().addCallback(dojo.hitch(this, function(){this.submit(args)}));
		}
	},
		
	apply: function(/*Object*/args){
		// summary: applies a change associated with a result to the page
		// args: contains args.id which is the id of the selected item
		if(args.id == this.current) return;
		if(args.id == this.currentSet) this.makeDirty(false);
		else if(this.dirty == false) this.makeDirty(true);
		this.current = args.id;	
		this._switchStylesheet(this.current);
	},
		
	undo: function(){
		// summary: reverts any changes made
		if(this.started) this.apply({id:this.currentSet});
	},

	beforeSubmit: function(/*Object*/args){
		// summary: set the metadata for the style in the content model store. Returns a Deferred
		//		which is fired when the controller is ready to be submitted.
		var dfd = new dojo.Deferred();
		var cbk = dojo.hitch(this, function(){
			if(this.started) this.store.setValue(this.item, "metadata[colorPalette]$", this.current);
			dfd.callback();
		});
		if(!this.store.isItemLoaded(this.item)) {
			this.store.loadItem({
				item: this.item,
				onItem: cbk,
				onError: args ? args.onError : null
			});
		}
		else cbk();
		return dfd;
	},
		
	submit: function(/*Object*/args){
		// summary: saves any pending changes to the server
		// args: args may contain an onComplete handler
		if(!this.dirty) { 
			if(args.onComplete) args.onComplete(); 
			return; 
		}
		var onComplete = dojo.hitch(this, function(){
			this.makeDirty(false);
			this.currentSet = this.current;
			if(args.onComplete) args.onComplete();
		});
		this.store.saveItems([this.item],{
			onComplete: onComplete,
			onError: args.onError
		});
	},
		
/***********************************************/
/*              Helper functions   		       */
/***********************************************/

	_switchStylesheet: function(title){
		// summary: switch to the stylesheet with the given title
		var i, currLink;
		for(i = 0; (currLink = document.getElementsByTagName("link")[i]); i++) {
			// if the link is a perferred stylesheet
			if(currLink.getAttribute("rel").indexOf("style") >= 0 && currLink.getAttribute("title")) { 
				// if the chosen theme is found
				if(currLink.getAttribute("title") == title) currLink.disabled = false;
				else currLink.disabled = true; 
			}
	    }
	},

	_loadCss: function(path, title, alternate, disabled){
		var link = dojo.create("link",{type:"text/css",rel:(alternate)?"alternate stylesheet":"stylesheet",href:path,media:"screen",disabled:disabled});
		if(title) link.title = title;
		var head = document.getElementsByTagName("head")[0];
		head.appendChild(link);
	}
}

}
