if(!dojo._hasResource["com.ibm.customize.SearchBar"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.customize.SearchBar"] = true;
// This is an input box which publishes all the words of the input's value as an array to a given event

dojo.provide("com.ibm.customize.SearchBar");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.bundles", "Shelf");

dojo.declare("com.ibm.customize.SearchBar",
	[dijit._Widget, dijit._Templated],
	{
		imagePath: ".",
		searchId: "",
		searchFieldText: "",
		searching: true,
		events: [],
		publishKeyword: "/epc/customize/search",	// the keyword to publish when a string is submitted
		templateString: '<div dojoAttachPoint="focusNode" class="lotusChunk lotusSearch">' +
							'<form role="search" action="" onsubmit="return false">' +
								'<label for="${searchBoxId}" class="ibmPortalHiddenText ibmHiddenText wpthemeAccess" dojoAttachPoint="searchFieldLabel">${searchFieldText}</label>' +
								'<input id="${searchBoxId}" dojoAttachEvent="onkeydown:newSearch" class="lotusText" type="text" value="${searchFieldText}" onfocus="this.value=\'\';" dojoAttachPoint="searchField"/>' +
								'<span class="lotusBtnImg" title="${submitSearchText}">' +
									'<input dojoAttachEvent="onclick:searchButton" class="lotusSearchButton" type="image" alt="${submitSearchText}" src="${imagePath}/blank.gif"/>' +
									'<span class="lotusAltText">Search</span>' +
								'</span>' +
							'</form>' +
						'</div>',
		
		constructor: function() {
			this.bundle = dojo.i18n.getLocalization("com.ibm.bundles", "Shelf");
			this.submitSearchText = this.bundle["shelf_submitSearch"];
		},
		
		postMixInProperties: function(){
			this.searchBoxId = this.searchId + "_search";
		},
		
		postCreate: function(){
			// summary: subscribe to the event that changes the default text in the search box
			this.events.push(dojo.subscribe("/epc/customize/changeSource"+this.searchId, this, this.changeInputValue));
		},
		
		enableSearch: function(){
			if(!this.searching){
				this.searching = true;
				dojo.style(this.searchField, "backgroundColor", "#FFFFFF");
				dojo.style(this.searchField, "borderColor", "#FFFFFF");
				this.searchField.removeAttribute("disabled");
			}
		},
		
		disableSearch: function(){
			if(this.searching){
				this.searching = false;
				dojo.style(this.searchField, "backgroundColor", "#CCCCCC");
				dojo.style(this.searchField, "borderColor", "#CCCCCC");
				dojo.attr(this.searchField, "disabled", true);
			}
		},
		
		changeInputValue: function(/*Object*/source){
			// summary: changes the text in the field
			if(source.hub.searchable) this.enableSearch();
			else this.disableSearch();
			if(source.searchStr) this.searchFieldText = source.hub.searchable ? source.searchStr : "";
			else this.searchFieldText = source.hub.searchable ? dojo.string.substitute(this.bundle["shelf_search"], [source.label]) : "";
			this.searchField.value = this.searchFieldLabel.innerHTML = this.searchFieldText;
		},
		
		newSearch: function(/*Event*/e){
			// summary: triggers when a user is typing 
			// Publishes an event when the user presses the enter key
			e = dojo.fixEvent(e, e.target);
			var key = e.keyCode;
		
			if(dojo.isIE && key == dojo.keys.ENTER)
				this.searchButton();
		},
		
		searchButton: function(){
			// summary: creates an array of the space separated search terms and publishes them to an event
			if(this.searching){
				var searchWords = (this.searchField.value == this.searchFieldText) ? "" : this.searchField.value;  // no search criteria if field = "Search xxxx"
				var searchArray = searchWords.split(" ");
				// publish the event to a specific id so not all instances of the receiving class respond
				dojo.publish(this.publishKeyword+this.searchId, [searchArray]);
			}
		},
		
		destroy: function(){
			dojo.forEach(this.events, dojo.unsubscribe);
			this.events = null;
			this.inherited(arguments);
		}
});

}
