if(!dojo._hasResource["com.ibm.lang.DeferredQueue"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.lang.DeferredQueue"] = true;
/*
 * @author allenbj
 */ 
dojo.provide("com.ibm.lang.DeferredQueue");

dojo.declare("com.ibm.lang.DeferredQueue",
	null,
	{
		constructor: function(/*Deferred?*/ def) {
			this.curDef = def;
			this.firstDef = def;
		},
		_addCallbacks: function(/*Deferred*/ source, /*Deferred*/ target) {
			source.addCallbacks(
				function(res){target.callback(res); return res;},	// callback
				dojo.hitch(this, function(err){						// errback
					try{
						if(!err._raised) {
							this.raiseError(err);	// in case raiseError fails... we still guarantee all callbacks
							err._raised = true;
						}
					}catch(err2){}
					target.callback(err);
					return err;
				})
			);
		},
		addBefore: function(/*Deferred*/ def) {
			// summary: Inserts a Deferred into the front of the queue which will fire the 
			// 		Deferred that is currently in the front of the queue when it calls back.
			//		Allows preprocessing or delaying of this DeferredQueue's firing.
			//		Note, if the queue has already fired, this will cause an error when the
			//		def argument callsback.
			if(!this.firstDef) this.firstDef = def;
			else {
				var oldFirst = this.firstDef;
				this.firstDef = def;
				this._addCallbacks(def, oldFirst);
			}
		},
		add: function(/*Deferred*/ def) {
			// summary: Adds a deferred to the queue which will be fired as a callback
			//		to the previous deferred in the queue.  If this is the first deferred
			//		to be added to the queue, firing it will start the queue.
			if(!this.firstDef) this.firstDef = def;
			if(this.curDef) {
				var oldCur = this.curDef;
				this.curDef = def;
				this._addCallbacks(oldCur, def);
			}
			else {
				this.curDef = def;
			}
			return this;
		},
		fire: function(res) {
			// summary: Starts the queue by firing the first deferred in the queue
			//		passing the argument to this function to the callback function of
			//		the first deferred.
			// res: Anything
			if(this.firstDef) this.firstDef.callback(res);
			return this;
		},
		raiseError: function(err) {
			// summary: Called whenever one of the Deferreds in the queue fires its errback.
			//		If an error is raised once by this and then a subsequent Deferred is errbacked
			//		with the exact same error, it will not be raised again.  However, if the next
			//		Deferred throws or returns a new error, that will be raised only once itself.
			//		This allows any errors to be raised once and only once without losing any of them.
			//		NOOP by default, so override this or connect to it to provide implementation.
		},
		destroy: function() {
			delete this.firstDef;
			delete this.curDef;
			delete this.raiseError;
		}
	}
);

}
