if(!dojo._hasResource["com.ibm.mashups.builder.model.ContextMenuLoader"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mashups.builder.model.ContextMenuLoader"] = true;
dojo.provide("com.ibm.mashups.builder.model.ContextMenuLoader");

dojo.require("com.ibm.mashups.builder.model.ContextMenuItem");

/**
 * This object is used to retrieve context menu items by returning a &nbsp;{@link com.ibm.mashups.enabler.Deferred Deferred} object
 * that returns those items either directly in synchronous mode or via the callback
 * in asynchronous mode.  The items returned by the &nbsp;{@link com.ibm.mashups.enabler.Deferred Deferred} must be an array of items
 * that follow the &nbsp;{@link com.ibm.mashups.builder.model.ContextMenuItem ContextMenuItem} format.
 * @ibm-spi
 * @ibm-module Builder
 */
dojo.declare("com.ibm.mashups.builder.model.ContextMenuLoader", null, {
	/**
	 * Returns a {@link com.ibm.mashups.enabler.Deferred Deferred} object that will pass an array of the items loaded by this object
	 * as the first argument to the callback.
	 * @ibm-spi
     * @param {String} contextMenuId  this is id of the context menu.  Examples: ContextMenu.page, ContextMenu.space, ContextMenu.toolbox, ContextMenu.modeSelector ContextMenu.widgetSkin, or any additional extension.  Must not be <code>null</code>.
     * @param {String} targetResourceId this is the ID of the resource to associate the decision for this menu choice with.  Must not be <code>null</code>.  
	 * @param {String} targetResourceType this is the resource type of the resource to associate the decision for this menu choice with.  May be <code>null</code>.
	 * Possible values for this could be "com.ibm.mashups.enabler.space.SpaceNode", "com.ibm.mashups.iwidget.widget.IWidgetDefinition", "com.ibm.mashups.enabler.navigation.NavigationNode",
	 * or any other type used by an extension.  
	 * @param {Object} someObject this allows an arbitrary object to be passed into the context menu loader in case it needs additional data for making the decisions.
	 * @return {com.ibm.mashups.enabler.Deferred} Deferred object that loads the data and fires the callback
	 * with an array of items conforming to the {@link com.ibm.mashups.builder.model.ContextMenuItem ContextMenuItem}
	 * format that are retrieved by this loader; never <code>null</code>.
	 */
	getItems: function(/*String*/ contextMenuId, /*String*/ targetResourceId, /*String*/ targetResourceType, /*Object*/ someObject){
	},
	
	/**
	 * Event that notifies the system that this loader's contents have changed and may be reloaded
	 * to avoid stale data.  Callers may call this function on a loader that has been registered
	 * to a particular context menu id or used as a contribution to an existing context menu.  The
	 * system listens to this event in order to notify any registered listeners on a context menu
	 * of the event.
	 * @ibm-spi
	 * @type void
	 */
	onChange: function() {
		
	}
});

}
