if(!dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList"] = true;
dojo.provide("com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojox.data.dom");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.SpaceManagerAwareMixin");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin");
dojo.require("com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants");

dojo.declare("com.ibm.mm.builder.iwidget.spacemanager.widget.SimpleSpacesList", 
        [dijit._Widget, dijit._Templated, 
        com.ibm.mm.builder.iwidget.spacemanager.widget.ModelAwareMixin], 
{
    templatePath : dojo.moduleUrl("com.ibm.mm.builder", "iwidget/spacemanager/widget/templates/SimpleSpacesList.html"),
    
    _subscriptions: null,
	_connections: null,
    _constants: com.ibm.mm.builder.iwidget.spacemanager.SpaceManagerConstants,
    _bundle: com.ibm.mm.builder.coreWidgetsStrings,
    
    eventService: com.ibm.mashups.services.ServiceManager.getService(com.ibm.mashups.iwidget.services.EventService.SERVICE_NAME),
    
    constructor : function() {
        this._subscriptions = [];
		this._connections = [];
		this.enablerUtil = com.ibm.mm.builder.utils.enablerUtil;
    },
    
    postMixinProperties : function() {
    },
    
    uninitialized: function() {
        dojo.forEach(this._subscriptions, dojo.unsubscribe);
    },
    
    postCreate : function() {
        this._subscriptions.push(dojo.subscribe(this._constants.Topic.Space.refreshRecentSpaces, dojo.hitch(this, this._render)));
        this._render();
    },
    
    _render : function() {
		dojo.forEach(this._connections,dojo.disconnect);
		this._connections = [];
        var self = this;
        var model = this.getModel();
        var bodyNode = dojo.query(".body", this.domNode)[0];
        dojo.empty(bodyNode);
        dojo.attr(bodyNode,{"tabindex":"-1","aria-labelledby":"recent_spaces_list"});
        model.fetch({
            onComplete : function(items) {
				if (items && items.length > 0) {
					var ul = dojo.doc.createElement("ul");
					bodyNode.appendChild(ul);
					dojo.forEach(items, function(item) {	
						var li = dojo.create("li");
						ul.appendChild(li);
						var link = dojo.create("a", {"href": "#", "spaceId": model.getValue(item, "id"), innerHTML: model.getValue(item, "title", self._bundle.I_SPACE_MANAGER_NO_TITLE)}, li);           
						self._connections.push(dojo.connect(link, "onclick", self, "onSpaceClick"));					
					});
				}else{
					dojo.create("div", { "id": "recent_spaces_hint", innerHTML: self._bundle.I_SPACE_MANAGER_RECENT_SPACES_HINT }, bodyNode);
                    dojo.removeAttr(bodyNode, "aria-labelledby");
                    dojo.attr(bodyNode,{"tabindex":"0", "aria-describedby":"recent_spaces_list recent_spaces_hint"});
				}
            },
            onError : function(err) {
                console.error(err);
            }
        });
    },
        
    onSpaceClick: function(event) {
        event = dojo.fixEvent(event);
        if (event && event.target) {
            var spaceId = dojo.attr(event.target, "spaceId");
			var spaceItem = {"id":spaceId, "title": this.enablerUtil.getNodeTitle(com.ibm.mm.builder.utils.spaceUtil.getSpaceNode(spaceId)) || ""};
			dojo.publish(this._constants.Topic.Space.addToRecentSpaces, [spaceItem]);
            dojo.publish(this._constants.Topic.Space["switch"], [spaceId]);
        }
		return false;
    },

    getAssociatedModelNames : function() {
        return this.modelNames || [];
    }
});

}
