if(!dojo._hasResource["com.ibm.mm.builder.widget.ExtendableShadowMenu"]){ //_hasResource checks added by build. Do not use _hasResource directly in your code.
dojo._hasResource["com.ibm.mm.builder.widget.ExtendableShadowMenu"] = true;
/**
 * @author Jarod (zhangpy@cn.ibm.com)
 */
dojo.provide("com.ibm.mm.builder.widget.ExtendableShadowMenu");

dojo.require("com.ibm.mm.builder.widget.ShadowMenu");

/**
 * summary: Shadow menu with extension
 */
dojo.declare("com.ibm.mm.builder.widget.ExtendableShadowMenu", com.ibm.mm.builder.widget.ShadowMenu, {
	
	hasMorePage:false,
	
	currentPosition: 0,
	
	isLastItemShowed:false,
	
	loadedEntriesNumber:0,
	
	limitedSize:null,
	
	onOpen: function(){
		if (!this._arrowIsCreated) {
			this.upArrow = new com.ibm.mm.builder.widget.MenuItemArrow({type: "previous"});
			this.addChild(this.upArrow, 0);
			
			this.downArrow = new com.ibm.mm.builder.widget.MenuItemArrow({type: "next"});
			this.addChild(this.downArrow, this.loadedEntriesNumber + 1);	
			this._arrowIsCreated = true;
		}
		this.adjustMenu();
		this.inherited(arguments);
	},
	
	/*
	 * Show the arrows when then number is greater than page sizing
	 */
	adjustMenu: function(){
		var children = this.getChildren();
		for (var i = 0, len = children.length; i < len; i++) {
			var child = children[i];
			if (child.declaredClass == "com.ibm.mm.builder.widget.MenuItemArrow") {
				if (this.hasMorePage) {
					child.domNode.style.display = "";
					if (child.type === "previous") {
						child.setDisabled(this.currentPosition > 0 ? false : true);
						
					} else if (child.type === "next") {
						child.setDisabled(this.isLastItemShowed);
						
					} else {
						child.domNode.style.display = "none";
					}
				}
			}
			if (child.declaredClass == "dijit.PopupMenuItem" || child.constructor.superclass.declaredClass == "dijit.PopupMenuItem") {
				child.domNode.style.display = (i > this.currentPosition && i <= this.currentPosition + this.limitedSize) ? "" : "none";
			}
		}
	}
});

dojo.declare("com.ibm.mm.builder.widget.MenuItemArrow", [dijit.MenuItem], {
	
	type: null,
	
	templateString: 
		"<tr class='dijitReset dijitMenuItem MenuItemArrow' dojoAttachEvent='onmouseenter:_onHover,onmouseleave:_onUnhover' style='display:none;'>"+
	        "<td colspan='4'>"+
				"<div>"+
					"<img dojoAttachPoint='pageNextNode' dojoAttachEvent='onclick:_entryFlip,onkeypress:_onKeyPressEntryFlip'  class='NavigationMenuPageNext' alt='' tabindex=0 />"+
					"<span class='NavigationMenuPageDivider'></span>"+
					"<img  dojoAttachPoint='jumpNextPage' dojoAttachEvent='onclick:_pageFlip,onkeypress:_onKeyPressPageFlip'  class='NavigationMenuPageJump' alt='' tabindex=0 />"+
				"</div>"+
			"</td>"+
		"</tr>",
			
	postCreate: function(){
		this.imgPath = builderConfig.builderPath+ "/images/" + this.type;
        this.pageNextNode.src = this.imgPath + "_entry_disabled.png";
        this.jumpNextPage.src = this.imgPath + "_page_disabled.png";
	},
	
	_onKeyPressEntryFlip:function(e){
        if (e.keyCode === dojo.keys.ENTER){ this._entryFlip(e); }
	},
	
	_onKeyPressPageFlip: function(e) {
		if (e.keyCode === dojo.keys.ENTER) { this._pageFlip(e); }
	},
	
	setDisabled: function(/*Boolean*/ disabled){
        this.pageNextNode.src = this.imgPath + "_entry" + (disabled ? "_disabled" : "_enabled") + ".png";
        this.jumpNextPage.src = this.imgPath + "_page" + (disabled ? "_disabled" : "_enabled") + ".png";
		this.isDisabled = disabled;
	},
	
	_entryFlip: function(e){
		if (this.isDisabled) { return; }
		
		var parent = this.getParent();
		this._flipHelper(parent);
		parent.adjustMenu();
		if (parent.shadow) { parent.shadow.resize(); }
	},
	
	_flipHelper: function(parent){
		if (this.type === "previous") {
			if (parent.currentPosition > 0) {
				parent.currentPosition--;
				parent.isLastItemShowed = false;
			}
		}
		else if (this.type === "next") {
			var pages = parent.pages;
			if (!pages || parent.isLastItemShowed) { return; }
			
			if ((parent.currentPosition + parent.limitedSize) === parent.loadedEntriesNumber && pages.hasNext()) {
				var page = pages.next();
				var newItem = parent.createNewItem(page);
				dojo.forEach(parent.getChildren(), function(child){
					if (child.declaredClass === "com.ibm.mm.builder.widget.MenuItemArrow") {
						parent.addChild(newItem, parent.getIndexOfChild(child));
					}
				});
				parent.loadedEntriesNumber++;
				parent.currentPosition++;
				parent.isLastItemShowed = !pages.hasNext();
			}
			else {
				parent.currentPosition++;
				parent.isLastItemShowed = (parent.currentPosition + parent.limitedSize) === parent.loadedEntriesNumber;
			}
		}
	},
	
	_pageFlip: function(e){
		if (this.isDisabled) { return; }
		
		var parent = this.getParent();
		for (var i = 0; i < parent.limitedSize; i++) {
			this._flipHelper(parent);
		}
		parent.adjustMenu();
		if (parent.shadow) {
			parent.shadow.resize();
		}
	},
	
	focus: function(){
		// this throws on IE (at least) in some scenarios
		try{ dijit.focus(this.pageNextNode); }catch(e){}
	}
});

}
