/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.ModifiableLocalized");

dojo.require("com.ibm.mashups.enabler.Localized");

/**
 * Modifiable interface providing methods to set title and description of a
 * resource.
 * @ibm-api
 * @ibm-module Base
 */
dojo.declare("com.ibm.mashups.enabler.ModifiableLocalized", com.ibm.mashups.enabler.Localized, {
    /**
     * Sets the title for the given locale.
     * @param {String} title    title to set; must not be <code>null</code>
     * @param {String} locale   locale to set the title for; must not be <code>null</code>
     * @return {String} the former title; if none existed, <code>null</code> is returned
     */
    setTitle: function(title, locale){
    },
    
    /**
     * Confirms whether setting the title for the given locale is possible.
     * @param {String} title    title to set; must not be <code>null</code>
     * @param {String} locale   locale to set the title for; must not be <code>null</code>
     * @return {Boolean} true if the value can be set, otherwise false.
     */
    confirmSetTitle: function(title, locale){
    },
    
    /**
     * Removes the title for the given locale.
     * @param {String} locale locale of the title to remove; must not be <code>null</code>
     * @type void
     */
    removeTitle: function(locale){
    },
    
    /**
     * Indicates if the title for the specified locale may be removed.
     * @param {String} locale locale for which to indicate if the title may be removed; must not be <code>null</code>
     * @return {Boolean} <code>true</code> if the title can be removed, otherwise <code>false</code>.
     */
    confirmRemoveTitle: function(locale){
    },
    
    /**
     * Removes all titles.
     * @type void
     */
    removeTitles: function(){
    },
    
    /**
     * Indicates if the titles for all locales may be removed.
     * @return {Boolean} <code>true</code> if all titles can be removed, otherwise
     * <code>false</code>.
     */
    confirmRemoveTitles: function(){
    },
    
    /**
     * Sets the description for the given locale.
     * @param {String} desc     description to set; must not be <code>null</code>
     * @param {String} locale   locale to set the description for; must not be <code>null</code>
     * @return {String} the former description; if none existed, <code>null</code> is returned
     */
    setDescription: function(desc, locale){
    },
    
    /**
     * Confirms whether setting the description for the given locale is possible.
     * @param {String} desc     description to set; must not be <code>null</code>
     * @param {String} locale   locale to set the description for; must not be <code>null</code>
     * @return {Boolean} true if the value can be set, otherwise false.
     */
    confirmSetDescription: function(desc, locale){
    },
    
    /**
     * Removes the description for the given locale.
     * @param {String} locale locale of the description to remove; must not be <code>null</code>
     * @type void
     */
    removeDescription: function(locale){
    },
    
    /**
     * Indicates if the description for the specified locale may be removed.
     * @param {String} locale locale for which to indicate if the description may be removed; must not be <code>null</code>
     * @return {Boolean} <code>true</code> if the description can be removed, otherwise <code>false</code>.
     */
    confirmRemoveDescription: function(locale){
    },
    
    /**
     * Removes all description.
     * @type void
     */
    removeDescriptions: function(){
    },
    
    /**
     * Indicates if the description for all locales may be removed.
     * @return {Boolean} <code>true</code> if all descriptions can be removed, otherwise
     * <code>false</code>.
     */
    confirmRemoveDescriptions: function(){
    }
});
