/* Copyright IBM Corp. 2013  All Rights Reserved.                    */
dojo.provide("com.ibm.mashups.enabler.model.Factory");

//<INTERFACE>
dojo.require("com.ibm.mashups.enabler.catalog.Factory");
dojo.require("com.ibm.mashups.enabler.navigation.Factory");
//dojo.require("com.ibm.mashups.enabler.model.SharedNavigationModel");
dojo.require("com.ibm.mashups.enabler.theme.Factory");
dojo.require("com.ibm.mashups.enabler.user.Factory");
dojo.require("com.ibm.mashups.enabler.remote.Factory");
dojo.require("com.ibm.mashups.enabler.template.Factory");
// removing because space factory is not lazy load enabled
//dojo.require("com.ibm.mashups.enabler.space.Factory");
//dojo.require("com.ibm.mashups.enabler.model.SpaceExtensionModel");

/**
 * Interface representing a model factory.
 *
 * Please note that the model factory creates only one instance of a model and
 * returns this instance every time the respective get-method is called.
 *
 * @deprecated Use the model factories in the sub-packages of the respective models
 */
dojo.declare("com.ibm.mashups.enabler.model.Factory", null, {

    /**
     * Returns the catalog category model.
     *
     * @ibm-api
     * @ibm-module CatalogModel
     *
     * @deprecated Use com.ibm.mashups.enabler.catalog.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.CatalogCategoryModel} catalog category model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getCatalogCategoryModel: function(){
    },
    
    /**
     * Returns the navigation model.
     *
     * @ibm-api
     * @ibm-module CoreModel
     *
     * @deprecated Use com.ibm.mashups.enabler.navigation.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.NavigationModel} navigation model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getNavigationModel: function(){
    },
    
    /**
     * Returns the shared navigation model.
     *
     * @ibm-api
     * @ibm-module CoreModel
     *
     * @deprecated Use com.ibm.mashups.enabler.navigation.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.SharedNavigationModel} shared navigation model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getSharedNavigationModel: function(){
    },
    
    /**
     * Returns the theme model.
     *
     * @ibm-api
     * @ibm-module CoreModel
     *
     * @deprecated Use com.ibm.mashups.enabler.theme.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.ThemeModel} theme model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getThemeModel: function(){
    },
    
    /**
     * Returns the user model.
     *
     * @ibm-api
     * @ibm-module UserModel
     * 
     * @deprecated Use com.ibm.mashups.enabler.user.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.UserModel} user model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getUserModel: function(){
    },
    
    /**
     * Returns the remote model.
     *
     * @ibm-api
     * @ibm-module RemoteModel
     *
     * @deprecated Use com.ibm.mashups.enabler.remote.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.RemoteModel} remote model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getRemoteModel: function(){
    },
    
    /**
     * Returns the template model.
     *
     * @ibm-api
     * @ibm-module SpaceModel
     *
     * @deprecated Use com.ibm.mashups.enabler.template.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.TemplateModel} template model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getTemplateModel: function(){
    },
    
    /**
     * Returns the space model.
     *
     * @ibm-api
     * @ibm-module SpaceModel
     *
     * @deprecated Use com.ibm.mashups.enabler.space.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.SpaceModel} space model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getSpaceModel: function(){
    },
    
    /**
     * Returns the space extension model.
     *
     * @ibm-api
     * @ibm-module SpaceModel
     *
     * @deprecated Use com.ibm.mashups.enabler.space.Factory instead.
     *
     * @return {com.ibm.mashups.enabler.model.SpaceExtensionModel} space extension model model, may be <code>null</code> if the aspect is not supported by the server runtime
     */
    getSpaceExtensionModel: function(){
    }
});
//</INTERFACE>

dojo.require("com.ibm.mm.enabler.model.FactoryImpl");
